--# Copyright (C) @BABOLO  2002..2008 http://www.babolo.ru/
--# Copyright (C) 2005 Michael Deryugin <dem@pikenet.ru>
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: pglib_ip.sql.m4,v 1.2 2009/07/03 13:47:55 babolo Exp $

CREATE OR REPLACE FUNCTION inet(int4) RETURNS inet
 AS '$libdir/pglib_ip.so.VMAJOR', 'int4_inet'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION inet(int4)        IS ' int4  IP ';

CREATE OR REPLACE FUNCTION inet(int8) RETURNS inet
 AS '$libdir/pglib_ip.so.VMAJOR', 'int8_inet'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION inet(int8)        IS ' int8  IP ';

CREATE OR REPLACE FUNCTION int4(inet) RETURNS int4
 AS '$libdir/pglib_ip.so.VMAJOR', 'inet_int4'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION int4(inet)        IS ' IP   int4';

CREATE OR REPLACE FUNCTION int8(inet) RETURNS int8
 AS '$libdir/pglib_ip.so.VMAJOR', 'inet_int8'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION int8(inet)        IS ' IP   int8';

CREATE OR REPLACE FUNCTION ip_set(inet, int) RETURNS SETOF inet
 AS '$libdir/pglib_ip.so.VMAJOR', 'ip_set'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION ip_set(inet, int) IS '       ';

CREATE OR REPLACE FUNCTION ip_set(inet) RETURNS SETOF inet
 AS 'SELECT ip_set($1, 32)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION ip_set(inet)      IS '    ';

dnl CREATE OR REPLACE FUNCTION inet_type(inet) RETURNS int2
dnl  AS '$libdir/pglib_ip.so.VMAJOR', 'inet_type'
dnl  LANGUAGE C IMMUTABLE STRICT
dnl ;
dnl COMMENT ON FUNCTION inet_type(inet)   IS '   inet/cidr';

CREATE OR REPLACE FUNCTION ip_supernet(inet) RETURNS SETOF inet
 AS '$libdir/pglib_ip.so.VMAJOR', 'ip_supernet'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION ip_supernet(inet) IS '    ';

--#
CREATE OR REPLACE FUNCTION ipaggr_in(cstring) RETURNS ipaggr
 AS '$libdir/pglib_ip.so.VMAJOR', 'ipaggr_in'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION ipaggr_in(cstring)        IS '   IP ';

CREATE OR REPLACE FUNCTION ipaggr_out(ipaggr) RETURNS cstring
 AS '$libdir/pglib_ip.so.VMAJOR', 'ipaggr_out'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION ipaggr_out(ipaggr)        IS ' IP   ';

CREATE OR REPLACE FUNCTION add_net(ipaggr, inet) RETURNS ipaggr
 AS '$libdir/pglib_ip.so.VMAJOR', 'add_net'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION add_net(ipaggr, inet)     IS '  IP  ';

CREATE OR REPLACE FUNCTION sub_net(ipaggr, inet) RETURNS ipaggr
 AS '$libdir/pglib_ip.so.VMAJOR', 'sub_net'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION sub_net(ipaggr, inet)     IS '  IP  ';

CREATE OR REPLACE FUNCTION add_ipaggr(ipaggr, ipaggr) RETURNS ipaggr
 AS '$libdir/pglib_ip.so.VMAJOR', 'add_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION add_ipaggr(ipaggr, ipaggr)IS '  IP ';

CREATE OR REPLACE FUNCTION sub_ipaggr(ipaggr, ipaggr) RETURNS ipaggr
 AS '$libdir/pglib_ip.so.VMAJOR', 'sub_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION sub_ipaggr(ipaggr, ipaggr)IS '  IP ';

CREATE OR REPLACE FUNCTION inter_ipaggr(ipaggr, ipaggr) RETURNS ipaggr
 AS '$libdir/pglib_ip.so.VMAJOR', 'inter_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;

CREATE OR REPLACE FUNCTION show_net(ipaggr) RETURNS SETOF cidr
 AS '$libdir/pglib_ip.so.VMAJOR', 'show_net'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION show_net(ipaggr)          IS ' IP    ';

CREATE OR REPLACE FUNCTION check_net(ipaggr, inet) RETURNS boolean
 AS '$libdir/pglib_ip.so.VMAJOR', 'check_net'
 LANGUAGE C IMMUTABLE STRICT
;

CREATE TYPE ipaggr (
   internallength = VARIABLE, 
   input = ipaggr_in,
   output = ipaggr_out,
   alignment = double,
   storage = external
);

CREATE AGGREGATE sum_net (
    sfunc = add_net,
    basetype = inet,
    stype = ipaggr,
    initcond = 'f'
);
COMMENT ON AGGREGATE sum_net(inet)            IS '   IP ';

CREATE OPERATOR + (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = add_ipaggr,
    commutator = +
);

CREATE OPERATOR - (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = sub_ipaggr,
    commutator = -
);

CREATE OPERATOR * (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = inter_ipaggr,
    commutator = *
);

CREATE OPERATOR + (
    leftarg = ipaggr,
    rightarg = inet,
    procedure = add_net,
    commutator = +
);

CREATE OPERATOR - (
    leftarg = ipaggr,
    rightarg = inet,
    procedure = sub_net,
    commutator = -
);
